## python-django-dynamic-fixture 4.0.1

=== Makefile ===
VERSION=4.0.1

# Python env tasks

clean:
	clear
	@find . -type f -name "*.py[co]" -delete
	@find . -type d -name "__pycache__" -delete
	rm -rf *.egg
	rm -rf *.egg-info/
	rm -rf *.log
	rm -rf ~*
	rm -rf data/
	rm -rf dist/
	rm -rf build/
	rm -rf .eggs/
	rm -rf .tox/
	#rm -rf env/

os_deps:
	brew install gdal

prepare:
	clear ; python3.11 -m venv env

deps:
	clear
	env/bin/python -m pip install --upgrade pip
	env/bin/python -m pip install --upgrade setuptools wheel
	env/bin/pip install -r requirements.txt
	env/bin/pip install -r requirements-dev.txt
	env/bin/pip list

shell:
	#clear ; env/bin/python -i -c "from ddf import *"
	clear ; env/bin/python manage.py shell
	# from ddf import *

# Python code tasks

compile:
	env/bin/python -OO -m compileall .

test:
	# Run specific test:
	# TESTS=django_dynamic_fixture.tests.FILE::CLASS::METHOD make test
	clear ; time env/bin/pytest --create-db --reuse-db --no-migrations ${TESTS}

testfailed:
	clear ; env/bin/pytest --create-db --reuse-db --no-migrations ${TESTS} --last-failed

config_postgres:
	psql -U postgres -c "create extension postgis"
	# set up postgresql
	psql -U postgres -c "create role cacheops login superuser"
	# postgis django backend requires these to exist
	psql -U postgres -c "create database cacheops"
	psql -U postgres -c "create database cacheops_slave"
	# create db and user
	psql -c "CREATE DATABASE ddf;" -U postgres
	psql -c "CREATE USER ddf_user WITH PASSWORD 'ddf_pass';" -U postgres
	psql -c "ALTER USER ddf_user CREATEDB;" -U postgres
	psql -c "ALTER USER ddf_user WITH SUPERUSER;" -U postgres

test_postgres:
	# TESTS=django_dynamic_fixture.tests.FILE::CLASS::METHOD make test_postgres
	clear ; env/bin/pytest --reuse-db --no-migrations --ds=settings_postgres ${TESTS}

test_mysql:
	# TESTS=django_dynamic_fixture.tests.FILE::CLASS::METHOD make test_mysql
	clear ; env/bin/pytest --reuse-db --no-migrations --ds=settings_mysql ${TESTS}

cov:
	clear ; env/bin/pytest --create-db --reuse-db --no-migrations -v --cov=django_dynamic_fixture --cov-report html
	cp htmlcov/index.html docs/source/_static/coverage.html
	open htmlcov/index.html

code_style:
	# Code Style
	clear ; env/bin/pylint ddf django_dynamic_fixture queries

code_checking:
	# Code error checking
	clear ; env/bin/python -m pyflakes ddf django_dynamic_fixture queries

code_feedbacks:
	# PEP8, code style and circular complexity
	clear ; env/bin/flake8 ddf django_dynamic_fixture queries

code_ruff:
	clear ; env/bin/ruff check .
	#clear ; env/bin/ruff check . --fix

check: code_style code_checking code_feedbacks code_ruff

install_precommit_hooks: code_ruff
	clear ; env/bin/ruff check .
	env/bin/pre-commit install

doc: cov
	clear ; cd docs ; make clean html ; open build/html/index.html

tox:
	#brew update ; brew install pyenv
	#pyenv install 3.8 3.9 3.10 3.11
	#pyenv versions
	#pyenv local 3.7 3.8 3.9 3.10 3.11
	clear ; time env/bin/tox --parallel all

build: clean os_deps prepare deps test cov

# Python package tasks

lib: clean test cov doc
	# 	clear ; env/bin/python setup.py build
	# 	clear ; env/bin/python setup.py sdist
	clear ; env/bin/python -m build
	clear ; env/bin/twine check dist/*

publish: lib
	# Fixing Python 3 Certificates
	# /Applications/Python\ 3.7/Install\ Certificates.command
	# Manual upload to PypI
	# http://pypi.python.org/pypi/THE-PROJECT
	# Go to 'edit' link
	# Update version and save
	# Go to 'files' link and upload the file
	clear ; env/bin/twine upload dist/* --username=UPDATE_ME --password=UPDATE_ME

# Git tasks

push: tox doc
	clear ; git push origin `git symbolic-ref --short HEAD`

tag:
	git tag ${VERSION}
	git push origin ${VERSION}

reset_tag:
	git tag -d ${VERSION}
	git push origin :refs/tags/${VERSION}


# GitHub Action

act:
	#brew install act
	time act --container-architecture linux/amd64 --matrix python_version:3.11 --matrix django_version:4.2

actall:
	time act --container-architecture linux/amd64

=== requirements.txt ===
# Database Drivers
#mysql-python
#psycopg2 # not pypy compatible
#psycopg2cffi # pypy2+ compatible

# DjangoGEO
geopy

# 3rd party libraries
# jsonfield>=2.1.1
django-json-field
django-polymorphic

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = ../env/bin/sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/DDF.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/DDF.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/DDF"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/DDF"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== debian/changelog ===
python-django-dynamic-fixture (4.0.1-1ubuntu1) questing; urgency=medium

  * Add Django 5 support
    - d/p/add-USE_TZ-to-ddf-settings.patch: Enforce timezone awareness in ddf
      settings.
    - d/p/use-django-tz-now-for-test.patch: Use django timezone version of now
      as reference for unit test.

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 14 Aug 2025 13:45:25 -0400

python-django-dynamic-fixture (4.0.1-1) unstable; urgency=medium

  * New upstream version 4.0.1

 -- Michael Fladischer <fladi@debian.org>  Mon, 25 Sep 2023 10:02:15 +0000

python-django-dynamic-fixture (4.0.0-1) unstable; urgency=medium

  * New upstream version 4.0.0
  * Drop patch to remove nose plugins, upstream dropped nose integration.
  * New name for README.md.

 -- Michael Fladischer <fladi@debian.org>  Wed, 06 Sep 2023 10:35:50 +0000

python-django-dynamic-fixture (3.1.2-1) unstable; urgency=low

  * Initial release (Closes: #1050041).

 -- Michael Fladischer <fladi@debian.org>  Fri, 18 Aug 2023 07:14:47 +0000

=== debian/control ===
Source: python-django-dynamic-fixture
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Michael Fladischer <fladi@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 pybuild-plugin-pyproject,
 python3-all,
 python3-django,
 python3-django-polymorphic,
 python3-gdal,
 python3-psycopg2,
 python3-pytest,
 python3-pytest-django,
 python3-setuptools,
 python3-sphinx,
 python3-sphinx-rtd-theme,
Standards-Version: 4.6.2
Homepage: https://github.com/paulocheque/django-dynamic-fixture
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-django-dynamic-fixture
Vcs-Git: https://salsa.debian.org/python-team/packages/python-django-dynamic-fixture.git
Rules-Requires-Root: no

Package: python-django-dynamic-fixture-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: create dynamic model instances for testing purposes (Documentation)
 Django Dynamic Fixture (DDF) is a complete and simple library to create dynamic
 model instances for testing purposes.
 .
 It lets you focus on your tests, instead of focusing on generating some dummy
 data which is boring and pollutes the test source code.
 .
 It exists to solve the anti-pattern of Static Fixtures and Factory objects.
 .
 Features:
  * Highly customizable: you can customize fields recursively
  * Deals with unique=True
  * Deals with cyclic dependencies (including self references)
  * Deals with many to many relationship (common M2M or M2M with additional
    data, i.e. through=’table’)
  * Deals with custom fields (especially if the custom field inherits from a
    django field)
  * Support for parallel tests
  * Deals with auto calculated attributes
  * It is easy to debug errors
 .
 This package contains the documentation.

Package: python3-django-dynamic-fixture
Architecture: all
Depends:
 python3-django,
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 python-django-dynamic-fixture-doc,
Description: create dynamic model instances for testing purposes (Python3 version)
 Django Dynamic Fixture (DDF) is a complete and simple library to create dynamic
 model instances for testing purposes.
 .
 It lets you focus on your tests, instead of focusing on generating some dummy
 data which is boring and pollutes the test source code.
 .
 It exists to solve the anti-pattern of Static Fixtures and Factory objects.
 .
 Features:
  * Highly customizable: you can customize fields recursively
  * Deals with unique=True
  * Deals with cyclic dependencies (including self references)
  * Deals with many to many relationship (common M2M or M2M with additional
    data, i.e. through=’table’)
  * Deals with custom fields (especially if the custom field inherits from a
    django field)
  * Support for parallel tests
  * Deals with auto calculated attributes
  * It is easy to debug errors
 .
 This package contains the Python 3 version of the library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PYBUILD_NAME=django-dynamic-fixture
export PYBUILD_TEST_ARGS=--import-mode=importlib

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

execute_before_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	PYTHONPATH=$(CURDIR) python3 -m sphinx -b html -d $(CURDIR)/docs/.build/.doctrees -N $(CURDIR)/docs/source $(CURDIR)/debian/python-django-dynamic-fixture-doc/usr/share/doc/python-django-dynamic-fixture-doc/html
endif

execute_after_dh_clean:
	rm -rf $(CURDIR)/docs/.build
